' FreeBASIC rewrite of bmp524 (writes to a single HAM file)
' BMP->MSX2 screen 7 with h-blank color changes

#lang "fblite"
option gosub

DIM aline(0 TO 511, 1 TO 3) AS short
DIM oline(0 TO 511, 1 TO 3) AS short
DIM clist(0 TO 511) AS short
DIM clist3(0 TO 511) AS short
DIM cprior(0 TO 511) AS short
DIM cprior2(0 TO 511) AS short
DIM pal(0 TO 15) AS short
DIM paluse(0 TO 15) AS short
DIM newpal(0 TO 15) AS short
DIM newpaluse(0 TO 15) AS short

dim paldump(0 to 1291) as ubyte
dim scrdump(0 to 54271) as ubyte

dim ch as string*1
dim ifile as string
dim ofile as string
DIM a AS ubyte
dim s as ushort
dim as integer ff1,ff2
dim as integer x,y,z,l,r,g,b,rf,gf,bf,nibbles,h,v,c
dim as integer colorsused,colorschanged,dmode,scrp,palp
dim as integer migiwari,u,zz,colors,maxcount

dmode=1         ' dithering enable/disable
colorsused = 14
colorschanged = 2

if command$="" then
?:? "picture converter for MSX screen 7 by DamageX V0.90"
?:? "usage:"
? "BMP2HAM image.BMP"
?:? "must be 24-bit bitmap, width=512, height<=424"
?
end
end if

ifile=command$
ff1=freefile
open ifile for binary as #ff1
if lof(ff1)=0 then close #ff1:kill ifile:? "empty input file":end

GET #ff1, 1, s
IF s <> &H4D42 THEN PRINT "infile is not a 'BM'": END

z=1:if len(ifile)>4 then z=len(ifile)-3
for x=len(ifile) to z step -1
ch=mid$(ifile,x,1)
if ch="." then x=x-1:goto a56
next x
x=len(ifile)
a56:
ofile=mid$(ifile,1,x)+".HAM"

ff2=freefile
open ofile for binary as #ff2
if lof(ff2)>0 then close #ff2:kill ofile:open ofile for binary as #ff2


' HAM file header
y=&H14d4148:put #ff2,,y
y=&H1070020:put #ff2,,y
y=&Hd40200:put #ff2,,y
y=&H1b238:put #ff2,,y
y=&H20:put #ff2,,y
y=&H52c:put #ff2,,y
y=&Ha38:put #ff2,,y
y=&Hde38:put #ff2,,y


' BMP dimensions
GET #ff1, 19, x
GET #ff1, , y


PRINT "field 0..."
scrp=0:palp=0
FOR v = 0 TO y - 2 STEP 2
GOSUB a240
NEXT v

l=&H21
put #ff2,l,paldump()
l=&HA39
put #ff2,l,scrdump()

PRINT "field 1..."
scrp=0:palp=0
FOR v = 1 TO y - 1 STEP 2
GOSUB a240
NEXT v

l=&H52D
put #ff2,l,paldump()
l=&HDE39
put #ff2,l,scrdump()

END


a240: ' clear color list
FOR z = 0 TO 511: clist(z) = 0: NEXT z

' read a line
l = 54 + ((y - 1) - v) * x * 3
maxcount = 1
GET #ff1, l, a
FOR h = 0 TO x - 1
GET #ff1, , a: r = a
GET #ff1, , a: g = a
GET #ff1, , a: b = a
rf = (r AND 224)
gf = (g AND 224)
bf = (b AND 224)
if ((v xor h) and 1)+dmode=2 then
if (r and 16) then if rf<193 then rf+=32
if (g and 16) then if gf<193 then gf+=32
if (b and 16) then if bf<193 then bf+=32
end if
aline(h, 1) = rf
aline(h, 2) = gf
aline(h, 3) = bf
z = rf + rf + (gf shr 2) + (bf shr 5)
clist(z) = clist(z) + 1
IF clist(z) > maxcount THEN maxcount = clist(z)
NEXT h

' process color list
colors = 1: cprior(0) = 0: clist(0) = maxcount + 1
FOR z = maxcount TO 1 STEP -1
FOR zz = 1 TO 511
IF clist(zz) = z THEN cprior(colors) = zz: colors = colors + 1
NEXT zz
NEXT z

' color selection for first line only
IF v < 2 THEN
FOR z = 0 TO 15: pal(z) = 0: paluse(z) = 0: NEXT z

IF colors < colorsused + 1 THEN
FOR z = 1 TO 3
FOR zz = 0 TO 511
oline(zz, z) = aline(zz, z)
NEXT zz
NEXT z
FOR z = 0 TO colors - 1
pal(z) = cprior(z)
paluse(z) = 1
NEXT z
GOTO a210
END IF

diff = 2
FOR z = 0 TO 511
clist3(z) = z
NEXT z
a60:
FOR z = colors - 1 TO 1 STEP -1
c = cprior(z)
r = ((c AND 448) shr 6)
g = ((c AND 56) shr 3)
b = (c AND 7)
FOR zz = 0 TO z - 1
rdiff = ABS(((cprior(zz) AND 448) shr 6) - r)
gdiff = ABS(((cprior(zz) AND 56) shr 3) - g)
bdiff = ABS((cprior(zz) AND 7) - b)
dif = rdiff * rdiff + gdiff * gdiff + bdiff * bdiff
IF dif < diff THEN GOTO a10
NEXT zz
GOTO a20
a10:
migiwari = cprior(zz)
FOR u = 0 TO 511
IF clist3(u) = c THEN clist3(u) = migiwari
NEXT u
clist(migiwari) = clist(migiwari) + clist(c)
a40:
IF zz = 0 THEN GOTO a30
IF clist(migiwari) >= clist(cprior(zz - 1)) THEN cprior(zz) = cprior(zz - 1): cprior(zz - 1) = migiwari: zz = zz - 1: GOTO a40
a30:
colors = colors - 1
IF colors = colorsused THEN GOTO a50
FOR zz = z TO colors - 1
cprior(zz) = cprior(zz + 1)
NEXT zz
a20:
NEXT z
diff = diff + 1: GOTO a60
a50:
'done?

colors = 1: pal(0) = 0: paluse(0) = 1
FOR h = 0 TO x - 1
rf = aline(h, 1)
gf = aline(h, 2)
bf = aline(h, 3)
z = rf + rf + (gf shr 2) + (bf shr 5)
c = clist3(z)
FOR zz = 0 TO colors - 1
IF pal(zz) = c THEN GOTO a70
NEXT zz
pal(colors) = c: paluse(colors) = 1: colors = colors + 1
a70:
oline(h, 1) = ((c AND 448) shr 1)
oline(h, 2) = ((c AND 56) shl 2)
oline(h, 3) = ((c AND 7) shl 5)
NEXT h

a210:
END IF

' color selection for other lines
IF v > 1 THEN

' write new prioritized color list, including up to _x_ colors from previous
' line which are then placed at the beginning of the new list
FOR z = 0 TO 15: newpaluse(z) = 0: newpal(z) = -1: NEXT z
oldcolors = 0
FOR z = 0 TO colors - 1
c = cprior(z)
FOR zz = 0 TO 15
IF paluse(zz) = 0 THEN GOTO a80
IF pal(zz) = c THEN
cprior2(oldcolors) = c
oldcolors = oldcolors + 1
newpaluse(zz) = 1: newpal(zz) = c
IF oldcolors = colorsused - colorschanged THEN GOTO a90
GOTO a81
END IF
a80:
NEXT zz
a81:
NEXT z
a90:
newcolors = oldcolors
FOR z = 0 TO colors - 1
c = cprior(z)
FOR zz = 0 TO newcolors - 1
IF c = cprior2(zz) THEN GOTO a100
NEXT zz
cprior2(newcolors) = c: newcolors = newcolors + 1
a100:
NEXT z

diff = 2
FOR z = 0 TO 511
clist3(z) = z
NEXT z
IF newcolors - oldcolors < colorschanged + 1 THEN GOTO a120
a110:
FOR z = newcolors - 1 TO oldcolors STEP -1
c = cprior2(z)
r = ((c AND 448) shr 6)
g = ((c AND 56) shr 3)
b = (c AND 7)
FOR zz = 0 TO z - 1
rdiff = ABS(((cprior2(zz) AND 448) shr 6) - r)
gdiff = ABS(((cprior2(zz) AND 56) shr 3) - g)
bdiff = ABS((cprior2(zz) AND 7) - b)
dif = rdiff * rdiff + gdiff * gdiff + bdiff * bdiff
IF dif < diff THEN GOTO a130
NEXT zz
GOTO a140
a130:
migiwari = cprior2(zz)
FOR u = 0 TO 511
IF clist3(u) = c THEN clist3(u) = migiwari
NEXT u
clist(migiwari) = clist(migiwari) + clist(c)
a150:
IF zz < oldcolors + 1 THEN GOTO a160
IF clist(migiwari) > clist(cprior2(zz - 1)) THEN cprior2(zz) = cprior2(zz - 1): cprior2(zz - 1) = migiwari: zz = zz - 1: GOTO a150
a160:
newcolors = newcolors - 1
IF newcolors - oldcolors < colorschanged + 1 THEN GOTO a120
FOR zz = z TO newcolors - 1
cprior2(zz) = cprior2(zz + 1)
NEXT zz
a140:
NEXT z
diff = diff + 1: GOTO a110
a120:
'done?

FOR h = 0 TO 511
rf = aline(h, 1)
gf = aline(h, 2)
bf = aline(h, 3)
z = rf + rf + (gf shr 2) + (bf shr 5)
c = clist3(z)
FOR z = 0 TO 15
IF newpal(z) = c THEN GOTO a181
NEXT z
FOR z = 0 TO 15
IF paluse(z) = 0 THEN GOTO a180
NEXT z
' CONDITION THAT SHOULD NOT HAPPEN (more color changes than free spots)
PRINT "ugh": END
a180:
newpal(z) = c: newpaluse(z) = 1: pal(z) = -1: paluse(z) = 1
a181:
oline(h, 1) = ((c AND 448) shr 1)
oline(h, 2) = ((c AND 56) shl 2)
oline(h, 3) = ((c AND 7) shl 5)
NEXT h


IF (v AND 510) = 2 THEN
'write first palette
FOR z = 0 TO 15
c = newpal(z)
r = ((c AND 448) shr 6)
g = ((c AND 56) shr 3)
r = r + ((c AND 7) shl 4)
paldump(palp)=r:palp+=1
paldump(palp)=g:palp+=1
NEXT z
GOTO a200
END IF

' write color changes

changes = 0
FOR z = 0 TO 15
IF newpaluse(z) = 0 THEN GOTO a190
IF pal(z) = newpal(z) THEN goto a190
c = newpal(z)
paldump(palp)=z:palp+=1
r = ((c AND 448) shr 6)
g = ((c AND 56) shr 3)
r = r + ((c AND 7) shl 4)
paldump(palp)=r:palp+=1
paldump(palp)=g:palp+=1
changes = changes + 1
IF changes = colorschanged THEN GOTO a200
a190:
NEXT z

IF changes < colorschanged THEN
FOR z = changes TO colorschanged - 1
FOR zz = 0 TO 15
IF paluse(zz) = 0 THEN GOTO a170
NEXT zz
' CONDITION THAT SHOULD NOT HAPPEN (no free colors)
PRINT "ugh2": END
a170:
c = newpal(zz)
paldump(palp)=zz:palp+=1
r = ((c AND 448) shr 6)
g = ((c AND 56) shr 3)
r = r + ((c AND 7) shl 4)
paldump(palp)=r:palp+=1
paldump(palp)=g:palp+=1
NEXT z
END IF

a200:
FOR z = 0 TO 15
pal(z) = newpal(z)
paluse(z) = newpaluse(z)
NEXT z

END IF

' write a line
altn = 0: nibbles = 0
FOR h = 0 TO x - 1
rf = oline(h, 1)
gf = oline(h, 2)
bf = oline(h, 3)
z = rf + rf + (gf shr 2) + (bf shr 5)
FOR zz = 0 TO 15
IF paluse(zz) = 1 THEN IF pal(zz) = z THEN nibbles = nibbles + zz: GOTO a222
NEXT zz
a222:
altn = 1 - altn
IF altn = 1 THEN nibbles = (nibbles shl 4): GOTO a220
scrdump(scrp)=nibbles:scrp+=1
nibbles = 0
a220:
NEXT h

RETURN

